Name: NX
Version: 1.5.0
Release: alt1

Summary: Proxy system for X11
Group: System/X11
License: GPL, MIT/X11 for X11 bits
Url: http://www.nomachine.com/

#Compression Libraries and Proxy Sources
Source0: nxproxy-%version-9.tar.gz
Source1: nxcomp-%version-65.tar.gz
Source2: nxcompext-%version-16.tar.gz
#X11 Support Libraries and Agent Sources
Source5: nx-X11-%version-15.tar.gz
Source6: nxagent-%version-93.tar.gz
#RFB Agent Sources
Source10: nxviewer-%version-14.tar.gz
#RDP Agent Sources
Source11: nxdesktop-%version-75.tar.gz
#NX Example Scripts
Source14: nxscripts-%version-11.tar.gz
Source15: nxagent
Source16: docs.tar.bz2

# SuSE patches
Patch0: NX.diff
Patch1: NX-noansi.diff
Patch2: p_XFree86-4.3-ppc64.diff
Patch3: NX-1.5.diff
Patch4: NX-bufferoverflow.diff
Patch5: NX-data-range.patch
Patch6: gcc4-friends.patch
Patch7: ppc-no-signed-char.diff

# ALT Linux patches
Patch10: nxdesktop-alt-ccache.patch

%add_findprov_lib_path %_libdir/NX/lib

# Automatically added by buildreq on Fri Dec 16 2005
BuildRequires: ed gcc-c++ libjpeg-devel libpng-devel libssl-devel libstdc++-devel xorg-x11-devel-static zlib-devel expat-devel audiofile-devel

Requires: xorg-x11

%set_verify_elf_method textrel=relaxed

%description
NX provides a proxy system for the X Window System.

%prep
%setup -q -c -n %name-%version -b1 -b2 -b5 -b6 -b10 -b11 -b14
%patch0
pushd nx-X11
%patch1
popd
#patch2 -p1
%patch3
%patch4
%patch5 -p1
%patch6
%patch7
#patch10
ln -s rdesktop.1 nxdesktop/doc/nxdesktop.1
cat >> nx-X11/config/cf/host.def << EOF
#ifdef  i386Architecture
#undef  DefaultGcc2i386Opt
#define DefaultGcc2i386Opt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  MipsArchitecture
#undef  DefaultGcc2MipsOpt
#define DefaultGcc2MipsOpt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef s390xArchitecture
#undef OptimizedCDebugFlags
#define OptimizedCDebugFlags $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
EOF

%build
%ifarch x86_64
export CFLAGS="%optflags -fPIC"
export CXXFLAGS="%optflags -fPIC"
%else
export CFLAGS="%optflags"
export CXXFLAGS="%optflags"
%endif

perl -pi -e"s|CXXFLAGS=.-O.*|CXXFLAGS=$CXXFLAGS|" */configure

# build Compression Library and Proxy
for i in nxcomp nxproxy; do
pushd $i
autoreconf -fi
%configure
%make_build
popd
done

# prepare Extended Compression Library
pushd nxcompext
autoreconf -fi
popd

# build X11 Support Libraries and Agents
pushd nx-X11
%make_build World
popd

# build Extended Compression Library
pushd nxcompext
%configure
%make_build
popd

# build RFB Agent
pushd nxviewer
xmkmf -a
cp -a /usr/X11R6/%_lib/libXp.so* ../nx-X11/exports/lib/
%make_build
popd

# build RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
./configure --prefix=%prefix --sharedir=%_datadir/NX
%make_build
popd
%endif

%install
mkdir -p %buildroot%_bindir/
mkdir -p %buildroot%_libdir/NX/lib/
mkdir -p %buildroot%_man1dir/

# install X11 Support Libraries and Agents
cp -a nx-X11/lib/X11/libX11.so.* \
      nx-X11/lib/Xext/libXext.so.* \
      nx-X11/lib/Xrender/libXrender.so.* \
      %buildroot%_libdir/NX/lib
install -m 755 nx-X11/programs/Xserver/nxagent %buildroot%_libdir/NX/
install -m 755 %SOURCE15 %buildroot%_bindir/

# install Compression Libraries and Proxy
cp -a nxcomp/libXcomp.so.* %buildroot%_libdir/NX/lib/
cp -a nxcompext/libXcompext.so.* %buildroot%_libdir/NX/lib/
install -m 755 nxproxy/nxproxy %buildroot%_libdir/NX/
ln -snf nxagent %buildroot%_bindir/nxproxy

# install RFB Agent
pushd nxviewer
%make_install DESTDIR=%buildroot install
mv %buildroot/usr/X11R6/bin/nxviewer %buildroot/usr/lib/NX
ln -snf nxagent %buildroot%_bindir/nxviewer
chmod 755 %buildroot%_bindir/nxviewer
mv %buildroot/usr/X11R6/bin/nxpasswd %buildroot%_bindir/
popd

# install RDP Agent
pushd nxdesktop
%make_install DESTDIR=%buildroot install
mv %buildroot%_bindir/nxdesktop %buildroot%_libdir/NX/
ln -snf nxagent %buildroot%_bindir/nxdesktop
chmod 755 %buildroot%_bindir/nxdesktop
mv %buildroot/usr/man/man1/nxdesktop.1 %buildroot%_man1dir/nxdesktop.1
#  rm -rf $RPM_BUILD_ROOT/usr/man
popd

# install scripts
mkdir -p %buildroot%_docdir/%name-%version/
cp -r nxscripts %buildroot%_docdir/%name-%version/
# documentation and license
tar xjf %SOURCE16 -C %buildroot%_docdir/%name-%version/
install -m 644 nxcomp/LICENSE %buildroot%_docdir/%name-%version/
for i in nxcomp nxdesktop; do
  mkdir %buildroot%_docdir/%name-%version/$i
done
install -m 644 nxcomp/README %buildroot%_docdir/%name-%version/nxcomp/
install -m 644 nxdesktop/README %buildroot%_docdir/%name-%version/nxdesktop/
rm -rf nxdesktop/doc/CVS
cp -r nxdesktop/doc %buildroot%_docdir/%name-%version/nxdesktop/

%files
%doc %_docdir/%name-%version/
%_bindir/nxagent
%_bindir/nxdesktop
%_bindir/nxpasswd
%_bindir/nxproxy
%_bindir/nxviewer
%dir %_libdir/NX
%_libdir/NX/nxagent
%_libdir/NX/nxdesktop
%_libdir/NX/nxproxy
%_libdir/NX/nxviewer
%dir %_libdir/NX/lib
%_libdir/NX/lib/libX11.so.*
%_libdir/NX/lib/libXcomp.so.*
%_libdir/NX/lib/libXcompext.so.*
%_libdir/NX/lib/libXext.so.*
%_libdir/NX/lib/libXrender.so.*
%ifnarch ppc ppc64 s390 s390x
%dir %_datadir/NX/
%_man1dir/nxdesktop.*
%_datadir/NX/keymaps-windows/
%endif

%changelog
* Thu Dec 01 2005 Igor Zubkov <icesik@altlinux.ru> 1.5.0-alt1
- Initial build for Sisyphus
